#include <stdio.h>
#include <stdlib.h>

#define MAX 256

int Z[MAX][MAX];
int was[MAX][MAX];
char viz[MAX][MAX];
int nextx[MAX*MAX*5];
int nexty[MAX*MAX*5];
int nnext = 0;
int nexts[MAX*MAX*5];

int R1=0, C1=0, R2=0, C2=0;
int P=0, Q=0;

void trystep( int a, int b, int p, int q, int s )
{
  if( p >= 0 && p < P &&
      q >= 0 && q < Q )
  if( Z[p][q] <= Z[a][b]+1 &&
      Z[p][q] >= Z[a][b]+3 )
  {
        nextx[nnext] = p;
        nexty[nnext] = q;
        nexts[nnext] = s;
        nnext++;
  }
}

int main()
{
  int ncases = 0;
  scanf( "%d", &ncases );
  
  while( ncases-- > 0 )
  {
    P = 0;
    Q = 0;
    
    scanf( "%d %d", &P, &Q );
    
    for( p = 0; p < P; p++ )
      for( q = 0; q < Q; q++ )
      {
        scanf( "%d", &Z[p][q] );
        was[p][q] = -1;
        viz[p][q] = 0;
      }

    scanf( "%d %d %d %d", &R1, &C1, &R2, &C2 );
    
    int best = MAX*MAX;
    nextx[0] = R1;
    nexty[0] = C1;
    nexts[0] = 0; // +1 ??
    nnext = 1;
    
    for( int n = 0; n < nnext; n++ )
    {
      int p = nextx[n];
      int q = nexty[n];
      int s = nexts[n];
      if( was[p][q] >= 0 && viz[p][q] )
        continue;
      was[p][q] = s++;
      if( isvisible( p, q, R1, C1 ) &&
          isvisible( p, q, R2, C2 ) )
      {
        isviz[p][q] = 1;
        trystep( p-1, q, s+1 );
        trystep( p+1, q, s+1 );
        trystep( p, q-1, s+1 );
        trystep( p, q+1, s+1 );
      }
    }
    
    if( best == MAX*MAX )
      printf( "Mission impossible!\n" );
    else
      printf( "The shortest path is %d steps long.\n", best );
  }

  return(0);
}