#include <stdio.h>
#include <stdlib.h>

int S,C;

void initpol(double *p)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=0;
}

void divpol(double *p,double d)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=p[i]/d;
}

void multpol(double *p,double d)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=p[i]*d;
}

void shiftpol(double *p)
{
  int i;
  for(i=S;i>0;i--) p[i]=p[i-1];
  p[0]=0;
}

void copypol(double *p1,double *p2)
{
  int i;
  for(i=0;i<S+1;i++) p2[i]=p1[i];
}

void sumpol(double *p1,double *p2,double *p3)
{
  int i;
  for(i=0;i<S+1;i++) p3[i]=p1[i]+p2[i];
}

double Horn(double *p, double x)
{
	double ret=0;
	int i;
	for(i=S-1;i>=0;i--) ret= ret*x +p[i];
	
	return(ret);
}

void HornDiv(double *p1, double a, double *p2)
{
	double t=0;
	int i;
	
	initpol(p2);
	for(i=S-1;i>=0;i--)
	{
		p2[i]=p1[i+1]+t;
		t=a*p2[i];
	}
}

void dP(double *p)
{
  int i;
  for(i=S;i>=0;i--) printf("%d  ", (int)p[i]);
	printf("\n");
}

int main()
{
  int t,i,j,k,l,xi[200];
  double ret,A;
  
  scanf("%d",&t);
  for(k=0;k<t;k++)
  {
    scanf("%d %d",&S,&C);
     for(l=1;l<=S;l++) scanf("%d",&xi[l]);

 		for(i=S+1;i<=S+C;i++)
 		{
 			ret=0;
 			A=1;
			for(j=2;j<=S;j++)
			{
				A=A*(double)(i-j)/(double)(1-j);
			}
			ret+= xi[1]*A;      
			printf("A=%f ret=%f\n",A,ret); 			

 			for(j=2;j<=S;j++)
 			{
 				A=A*(double)(i-(j-1))/
				  (double)(i-j)*(double)(j-1-S)/(double)(j-1);
 				ret+=xi[j]*A;
			printf("A=%f ret=%f\n",A,ret); 			
 			}
 			printf("%f", (ret +0.5) );
 			if(i==S+C) printf("\n"); else printf(" ");
 		}   
  }

  return(0);
}