#include <stdio.h>
#include <stdlib.h>

int S,C;

inline void initpol(double *p)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=0;
}

inline void divpol(double *p,double d)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=p[i]/d;
}

/*void multpol(double *p,double d)
{
  int i;
  for(i=0;i<S+1;i++) p[i]=p[i]*d;
}
*/
inline void shiftpol(double *p)
{
  int i;
  for(i=S;i>0;i--) p[i]=p[i-1];
  p[0]=0;
}

inline void copypol(double *p1,double *p2)
{
  int i;
  for(i=0;i<S+1;i++) p2[i]=p1[i];
}

inline void summultpol(double *p1,double *p2,double d,double *p3)
{
  int i;
  for(i=0;i<S+1;i++) p3[i]=p1[i]+p2[i]*d;
}

inline double Horn(double *p, double x)
{
	double ret=0;
	int i;
	for(i=S-1;i>=0;i--) ret= ret*x +p[i];
	
	return(ret);
}

inline void HornDiv(double *p1, double a, double *p2)
{
	double t=0;
	int i;
	
	p2[S]=0;
	for(i=S-1;i>=0;i--)
	{
		p2[i]=p1[i+1]+t;
		t=a*p2[i];
	}
}

void dP(double *p)
{
  int i;
  for(i=S;i>=0;i--) printf("%d  ", (int)p[i]);
	printf("\n");
}

int main()
{
  int t,i,j,k,l,xi[200];
  double p1[200],p2[200],p3[200],ps[200],tmpd;
  
  scanf("%d",&t);
  for(k=0;k<t;k++)
  {
    scanf("%d %d",&S,&C);
     for(l=1;l<=S;l++) scanf("%d",&xi[l]);

    {
			initpol(p2);p2[0]=1;
			for(j=1;j<=S;j++)
			{
				copypol(p2,p3);
				shiftpol(p2);
				//multpol(p3,-j);
				summultpol(p2,p3,-j,p2);
			  //dP(p2);
			  //dP(p3);
			}      
		copypol(p2,ps); 
    }
    //dP(ps);
    
    initpol(p1);
    for(i=1;i<=S;i++)
    {
			HornDiv(ps,i,p2);tmpd=xi[i];
			for(j=1;j<=S;j++)
			if (i!=j)
			{
				tmpd/=i-j;
			}      
			//multpol(p2,tmpd);
			summultpol(p1,p2,tmpd,p1); 
    }

 		for(i=S+1;i<=S+C;i++)
 		{
 			printf("%d",(int) (Horn(p1,i) +0.5) );
 			if(i==S+C) printf("\n"); else printf(" ");
 		}   
  }

  return(0);
}